/* 
 * This File is part of the iowj-project  
 * $Id: ListDevices.java,v 1.2 2005/07/24 18:06:29 Thomas Wagner Exp $
 * Copyright (C)2005 by Thomas Wagner
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package de.wagner_ibw.iow;

/**
 * Lists all connected IO Warrior devices.
 * @author Thomas Wagner
 */
public class ListDevices {
	
	public static void main(String[] args) {
	
		try {
			Iow devs  = new Iow();
			if (devs.openAllDevices() == 0) {
				System.out.println("Cannot find any connected IOW device(s)!");
				devs.exit(-1);
			} 
			System.out.println("Version of iowkit library is '" + devs.getVersion() + "'");
			System.out.println(devs.toString());
			devs.exit(0);
		}
		catch(Exception e) {
			e.printStackTrace();
			System.exit(-1);	
		}
	}
}
