/*
 * $Id: CarLocalisation.java,v 1.1 2005/02/27 15:00:32 Thomas Wagner Exp $
 * 
 * Created on 01.01.2004
 *
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package de.wagner_ibw.iow.appl;

//import java.io.InputStream;
//import java.net.URL;

import de.wagner_ibw.iow.Iow;
import de.wagner_ibw.iow.Iow24;
import de.wagner_ibw.iow.IowPort;
import de.wagner_ibw.iow.IowPortChangeListener;
import de.wagner_ibw.iow.LCD;
import de.wagner_ibw.iow.LCD2x40;
import de.wagner_ibw.iow.SpecialModeFunction;

/**
 * It is a simple test program.
 * 
 * @author Thomas Wagner
 *
 */
public class CarLocalisationNew implements Runnable, IowPortChangeListener{
	
	String  place0   = "Unbekannt";
	String  message0 = "Unbekannt verzogen";
	String  place1   = "Garage";
	String  message1 = "in der Garage";
	String  place2   = "Tankstelle";
	String  message2 = "an der Tankstelle";
	String  url      = "http://127.0.0.1/?Auto=";
	
	private int OUT_LINE = 2;	
	private int OUT_POS = 15;	
	
	private Iow devs;
	private LCD lcd = null;

	
	public  CarLocalisationNew() {
		devs = new Iow();
		if( devs.openAllDevices() == 0) {
			System.out.println("Cannot find any connected IOW device(s)!");
			devs.exit(-1);
		}
	}
	
	public  CarLocalisationNew(Iow devs) {
		this.devs = devs;
	}
	
	
	public static void main(String[] args) {
		CarLocalisationNew cl = new CarLocalisationNew();
		cl.doit();	
	}
				
	public void doit(){
		Iow24   dev24  = null;
				
		try {
			dev24 = devs.getIow24Device("0000016F");
		}
			catch(Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
		
		
		try {
			String temp = System.getProperty("place0","");
			if (temp.length() > 0)
				place0 = temp;	
				
			temp = System.getProperty("message0","");
			if (temp.length() > 0)
				message0 = temp;		
	
			temp = System.getProperty("place1","");
			if (temp.length() > 0)
				place1 = temp;

			temp = System.getProperty("message1","");
			if (temp.length() > 0)
				message1 = temp;
				
			temp = System.getProperty("place2","");
			if (temp.length() > 0)
				place2 = temp;

			temp = System.getProperty("message2","");
			if (temp.length() > 0)
				message2 = temp;
			
			temp = System.getProperty("url","");
			if (temp.length() > 0)
				url = temp;
		
			System.out.println("Starting Discrete Car Localisation ...");
			System.out.println("Place   0: " + place0);
			System.out.println("Message 0: " + message0);
			System.out.println("Place   1: " + place1);
			System.out.println("Message 1: " + message1);
			System.out.println("Place   2: " + place2);
			System.out.println("Message 2: " + message2);
			System.out.println("URL      : " + url);

			//lcd = new LCD(dev24,LCD4x20Generic.props);
			lcd = new LCD2x40();
			dev24.addSpecialModeFunctionImpl((SpecialModeFunction)lcd);
			System.out.println("\n"+dev24.toString());
			
			dev24.getPort(0).addPortChangeListener(this);
			Thread.sleep(100);
			lcd.setDisplayControl(true, false, false);	//Turn on display, cursor and blinking
			Thread.sleep(100);
			lcd.setEntryMode(true, false);				//Set cursor movement to right and no shifting
			Thread.sleep(100);
			
//--------------------			
			lcd.check();
			Thread.sleep(1100);
	
			lcd.clearLCD();		
			lcd.setCursorHome();
						//   1...5....1....5....2....5....3....5....0
			
			
			/*
			lcd.writeLine(1,false,"T-Com PI  CEBIT 2005");
			lcd.writeLine(3,false,"Das Auto ist:");
			*/
						
			lcd.writeLine(1,false,"T-Com PI  CEBIT 2005");
			lcd.writeLine(2,false,"Das Auto ist:");			
						
			lcd.writeLine(OUT_LINE,OUT_POS,true,"Initial");
							
			dev24.autonomous(true);
					
						
		}
		catch(Exception e ){
			e.printStackTrace();
		}
	}	
	
	
	/*
	 * Port Changed Callback
	 * @see de.wagner_ibw.iow.IowPortChangeListener#portChanged(de.wagner_ibw.iow.IowPort)
	 */
	public synchronized void  portChanged(IowPort port) {
		System.out.println("portChanged (index:"+port.getIndex()+")," + port.toString());
		String place;
		if(port.getIndex() == 0) {
			if(port.isBitClear(1)) { 
				lcd.writeLine(OUT_LINE,OUT_POS,true,message1);
				place = place1;
			}
			else if(port.isBitClear(2)) { 
				lcd.writeLine(OUT_LINE,OUT_POS,true,message2);
				place = place2;
			}
			else { 
				lcd.writeLine(OUT_LINE,OUT_POS,true,message0);
				place = place0;
			}
		}
	}
	
	public void run() {
		doit();
	}
	
	
}